#ifndef RP_PROCESS_LOG_CPP_H
#define RP_PROCESS_LOG_CPP_H

#include <rp_process_log/process_log_frame.h>

namespace rp_process_log {

#if 0
#define LOGF_IF(lv, cond, fmt, ...) if(cond) RP_##lv(fmt, ##__VA_ARGS__)
#define LOGF_IF_K(k, lv, cond, fmt, ...) if(cond) RP_##lv_K(k, fmt, ##__VA_ARGS__)
#else
#define LINK_PARAM(x, y) x##y
#define LOGF_IF(lv, cond, fmt, ...) do{if(!(cond)) break; RP_##lv(fmt, ##__VA_ARGS__); }while(false);
#define LOGF_IF_K(k, lv, cond, fmt, ...) do{ if(!(cond)) break; LINK_PARAM(RP_, lv##_K)(k, fmt, ##__VA_ARGS__); }while(false);

#define LOGF_IF_STREAM(lv, cond, log) do{if(!(cond)) break; LINK_PARAM(RP_, lv##_STREAM)(log); }while(false);
#define LOGF_IF_STREAM_K(k, lv, cond, log) do{if(!(cond)) break; LINK_PARAM(RP_, lv##_STREAM_K)(log, k); }while(false);


#endif
#define RP_DEBUG_IF( cond, fmt, ... ) LOGF_IF( DEBUG, cond, fmt, ##__VA_ARGS__ )

#define RP_INFO_IF( cond, fmt, ... ) LOGF_IF( INFO, cond, fmt, ##__VA_ARGS__ )

#define RP_WARN_IF( cond, fmt, ... ) LOGF_IF( WARN, cond, fmt, ##__VA_ARGS__ )

#define RP_ERROR_IF( cond, fmt, ... ) LOGF_IF( ERROR, cond, fmt, ##__VA_ARGS__ )

#define RP_FATAL_IF( cond, fmt, ... ) LOGF_IF_K( FATAL, cond, fmt, ##__VA_ARGS__ )

#define RP_DEBUG_IF_K(key, cond, fmt, ... ) LOGF_IF_K(key, DEBUG, cond, fmt, ##__VA_ARGS__ )

#define RP_INFO_IF_K(key, cond, fmt, ... ) LOGF_IF_K(key, INFO, cond, fmt, ##__VA_ARGS__ )

#define RP_WARN_IF_K(key, cond, fmt, ... ) LOGF_IF_K(key, WARN, cond, fmt, ##__VA_ARGS__ )

#define RP_ERROR_IF_K(key, cond, fmt, ... ) LOGF_IF_K(key, ERROR, cond, fmt, ##__VA_ARGS__ )

#define RP_FATAL_IF_K(key, cond, fmt, ... ) LOGF_IF_K(key, FATAL, cond, fmt, ##__VA_ARGS__ )


#define RP_DEBUG_IF_STREAM( cond, log ) LOGF_IF_STREAM( DEBUG, cond, log )

#define RP_INFO_IF_STREAM( cond, log ) LOGF_IF_STREAM( INFO, cond, log )

#define RP_WARN_IF_STREAM( cond, log ) LOGF_IF_STREAM( WARN, cond, log )

#define RP_ERROR_IF_STREAM( cond, log ) LOGF_IF_STREAM( ERROR, cond, log )

#define RP_FATAL_IF_STREAM( cond, log ) LOGF_IF_STREAM_K( FATAL, cond, log )

#define RP_DEBUG_IF_STREAM_K(key, cond, log ) LOGF_IF_STREAM_K(key, DEBUG, cond, log )

#define RP_INFO_IF_STREAM_K(key, cond, log ) LOGF_IF_STREAM_K(key, INFO, cond, log )

#define RP_WARN_IF_STREAM_K(key, cond, log ) LOGF_IF_STREAM_K(key, WARN, cond, log )

#define RP_ERROR_IF_STREAM_K(key, cond, log ) LOGF_IF_STREAM_K(key, ERROR, cond, log )

#define RP_FATAL_IF_STREAM_K(key, cond, log ) LOGF_IF_STREAM_K(key, FATAL, cond, log )


#ifdef ROS_DEBUG
#undef ROS_DEBUG
#endif
#define ROS_DEBUG RP_DEBUG


#ifdef ROS_INFO
#undef ROS_INFO
#endif
#define ROS_INFO RP_INFO


#ifdef ROS_WARN
#undef ROS_WARN
#endif
#define ROS_WARN RP_WARN


#ifdef ROS_ERROR
#undef ROS_ERROR
#endif
#define ROS_ERROR RP_ERROR


#ifdef ROS_FATAL
#undef ROS_FATAL
#endif
#define ROS_FATAL RP_FATAL


#ifdef ROS_DEBUG_ONCE
#undef ROS_DEBUG_ONCE
#endif
#define ROS_DEBUG_ONCE RP_DEBUG


#ifdef ROS_INFO_ONCE
#undef ROS_INFO_ONCE
#endif
#define ROS_INFO_ONCE RP_INFO


#ifdef ROS_WARN_ONCE
#undef ROS_WARN_ONCE
#endif
#define ROS_WARN_ONCE RP_WARN


#ifdef ROS_ERROR_ONCE
#undef ROS_ERROR_ONCE
#endif
#define ROS_ERROR_ONCE RP_ERROR


#ifdef ROS_FATAL_DEBUG
#undef ROS_FATAL_DEBUG
#endif
#define ROS_FATAL_DEBUG RP_FATAL


#ifdef ROS_DEBUG_STREAM
#undef ROS_DEBUG_STREAM
#endif
#define ROS_DEBUG_STREAM RP_DEBUG_STREAM


#ifdef ROS_INFO_STREAM
#undef ROS_INFO_STREAM
#endif
#define ROS_INFO_STREAM RP_INFO_STREAM


#ifdef ROS_WARN_STREAM
#undef ROS_WARN_STREAM
#endif
#define ROS_WARN_STREAM RP_WARN_STREAM


#ifdef ROS_ERROR_STREAM
#undef ROS_ERROR_STREAM
#endif
#define ROS_ERROR_STREAM RP_ERROR_STREAM


#ifdef ROS_FATAL_STREAM
#undef ROS_FATAL_STREAM
#endif
#define ROS_FATAL_STREAM RP_FATAL_STREAM


#ifdef ROS_INFO_THROTTLE
#undef ROS_INFO_THROTTLE
#endif
#define ROS_INFO_THROTTLE RP_INFO_THROTTLE


#ifdef ROS_INFO_STREAM_THROTTLE
#undef ROS_INFO_STREAM_THROTTLE
#endif
#define ROS_INFO_STREAM_THROTTLE RP_INFO_STREAM_THROTTLE


#ifdef ROS_DEBUG_STREAM_NAMED
#undef ROS_DEBUG_STREAM_NAMED
#endif
#define ROS_DEBUG_STREAM_NAMED(k,l) RP_DEBUG_STREAM_K(l,k)


#ifdef ROS_INFO_STREAM_NAMED
#undef ROS_INFO_STREAM_NAMED
#endif
#define ROS_INFO_STREAM_NAMED(k,l) RP_INFO_STREAM_K(l,k)


#ifdef ROS_WARN_STREAM_NAMED
#undef ROS_WARN_STREAM_NAMED
#endif
#define ROS_WARN_STREAM_NAMED(k,l) RP_WARN_STREAM_K(l,k)


#ifdef ROS_ERROR_STREAM_NAMED
#undef ROS_ERROR_STREAM_NAMED
#endif
#define ROS_ERROR_STREAM_NAMED(k,l) RP_ERROR_STREAM_K(l,k)


#ifdef ROS_FATAL_STREAM_NAMED
#undef ROS_FATAL_STREAM_NAMED
#endif
#define ROS_FATAL_STREAM_NAMED(k,l) RP_FATAL_STREAM_K(l,k)



#ifdef ROS_DEBUG_NAMED
#undef ROS_DEBUG_NAMED
#endif
#define ROS_DEBUG_NAMED RP_DEBUG_K


#ifdef ROS_INFO_NAMED
#undef ROS_INFO_NAMED
#endif
#define ROS_INFO_NAMED RP_INFO_K


#ifdef ROS_WARN_NAMED
#undef ROS_WARN_NAMED
#endif
#define ROS_WARN_NAMED RP_WARN_K


#ifdef ROS_ERROR_NAMED
#undef ROS_ERROR_NAMED
#endif
#define ROS_ERROR_NAMED RP_ERROR_K


#ifdef ROS_FATAL_NAMED
#undef ROS_FATAL_NAMED
#endif
#define ROS_FATAL_NAMED RP_FATAL_K

#if 1
#ifdef ROS_DEBUG_COND
#undef ROS_DEBUG_COND
#endif
#define ROS_DEBUG_COND RP_DEBUG_IF

#ifdef ROS_FATAL_COND
#undef ROS_FATAL_COND
#endif
#define ROS_FATAL_COND RP_FATAL_IF

#ifdef ROS_ERROR_COND
#undef ROS_ERROR_COND
#endif
#define ROS_ERROR_COND RP_ERROR_IF

#ifdef ROS_WARN_COND
#undef ROS_WARN_COND
#endif
#define ROS_WARN_COND RP_WARN_IF

#ifdef ROS_INFO_COND
#undef ROS_INFO_COND
#endif
#define ROS_INFO_COND RP_INFO_IF

#ifdef ROS_DEBUG_COND_NAMED
#undef ROS_DEBUG_COND_NAMED
#endif
#define ROS_DEBUG_COND_NAMED RP_DEBUG_IF_K

#ifdef ROS_FATAL_COND_NAMED
#undef ROS_FATAL_COND_NAMED
#endif
#define ROS_FATAL_COND_NAMED RP_FATAL_IF_K

#ifdef ROS_ERROR_COND_NAMED
#undef ROS_ERROR_COND_NAMED
#endif
#define ROS_ERROR_COND_NAMED RP_ERROR_IF_K

#ifdef ROS_WARN_COND_NAMED
#undef ROS_WARN_COND_NAMED
#endif
#define ROS_WARN_COND_NAMED RP_WARN_IF_K

#ifdef ROS_INFO_COND_NAMED
#undef ROS_INFO_COND_NAMED
#endif
#define ROS_INFO_COND_NAMED RP_INFO_IF_K




#ifdef ROS_DEBUG_STREAM_COND
#undef ROS_DEBUG_STREAM_COND
#endif
#define ROS_DEBUG_STREAM_COND RP_DEBUG_IF_STREAM

#ifdef ROS_FATAL_STREAM_COND
#undef ROS_FATAL_STREAM_COND
#endif
#define ROS_FATAL_STREAM_COND RP_FATAL_IF_STREAM

#ifdef ROS_ERROR_STREAM_COND
#undef ROS_ERROR_STREAM_COND
#endif
#define ROS_ERROR_STREAM_COND RP_ERROR_IF_STREAM

#ifdef ROS_WARN_STREAM_COND
#undef ROS_WARN_STREAM_COND
#endif
#define ROS_WARN_STREAM_COND RP_WARN_IF_STREAM

#ifdef ROS_INFO_STREAM_COND
#undef ROS_INFO_STREAM_COND
#endif
#define ROS_INFO_STREAM_COND RP_INFO_IF_STREAM

#ifdef ROS_DEBUG_STREAM_COND_NAMED
#undef ROS_DEBUG_STREAM_COND_NAMED
#endif
#define ROS_DEBUG_STREAM_COND_NAMED RP_DEBUG_IF_STREAM_K

#ifdef ROS_FATAL_STREAM_COND_NAMED
#undef ROS_FATAL_STREAM_COND_NAMED
#endif
#define ROS_FATAL_STREAM_COND_NAMED RP_FATAL_IF_STREAM_K

#ifdef ROS_ERROR_STREAM_COND_NAMED
#undef ROS_ERROR_STREAM_COND_NAMED
#endif
#define ROS_ERROR_STREAM_COND_NAMED RP_ERROR_IF_STREAM_K

#ifdef ROS_WARN_STREAM_COND_NAMED
#undef ROS_WARN_STREAM_COND_NAMED
#endif
#define ROS_WARN_STREAM_COND_NAMED RP_WARN_IF_STREAM_K

#ifdef ROS_INFO_STREAM_COND_NAMED
#undef ROS_INFO_STREAM_COND_NAMED
#endif
#define ROS_INFO_STREAM_COND_NAMED RP_INFO_IF_STREAM_K
#endif

}

#endif  // ONE_PUNCH_PROCESS_LOG_BASE_H
