﻿#ifndef RP_PROCESS_LOG_CPP_FORKER_H
#define RP_PROCESS_LOG_CPP_FORKER_H

#include <deque>
#include <chrono>
#include <mutex>
#include <thread>
#include <condition_variable>
#include <rp_process_log/process_log_define.h>
#include <rp_process_log/process_log_cpp_base.h>

namespace rp_process_log {



CLASS_FORWARD(ProcessLogCppForker)

/**
*  @class ProcessLogCppForker
*  @brief brief 日志处理分流类，只用在处理流入口处
*  @author luyp
*/
class ProcessLogCppForker : public ProcessLogCppBase
{
public:
    ProcessLogCppForker(const char* module);
    virtual ~ProcessLogCppForker();
    virtual void setConfig(const char* key, const char* val) override;
    virtual bool init(const char*) override;
    virtual bool process(LogRecordInfoPtr) override;
};

}

#endif  // RP_PROCESS_LOG_CPP_FORKER_H
