#ifndef RP_PROCESS_LOG_CPP_FORMATER_H
#define RP_PROCESS_LOG_CPP_FORMATER_H

#include <chrono>
#include <rp_process_log/process_log_define.h>
#include <rp_process_log/process_log_cpp_base.h>

namespace rp_process_log {

//设置日志显示数据
#define CONFIG_KEY_SHOW_INFO          "show_info"
//显示日志等级
#define CONFIG_VAL_LEVEL              "level"
//显示日志时间
#define CONFIG_VAL_TIME               "time"
//显示所在文件
#define CONFIG_VAL_FILE               "file"
//显示所在行数
#define CONFIG_VAL_LINE               "line"
//显示关键字
#define CONFIG_VAL_KEY                "key"
//显示模块名
#define CONFIG_VAL_MODULE             "module"
//显示函数名
#define CONFIG_VAL_FUNCTION           "function"
//显示函数名
#define CONFIG_VAL_COLOR              "color"
//设置每条日志长度，0为不限
#define CONFIG_KEY_LOG_MAX_SIZE       "log_max_size"

CLASS_FORWARD( ProcessLogCppFormatter )

/**
*  @class ProcessLogCppFormater
*  @brief 日志处理格式化类
*  @author luyp
*/
class ProcessLogCppFormatter : public ProcessLogCppBase
{
public:
 ProcessLogCppFormatter(const char* module);
    virtual ~ProcessLogCppFormatter() = default;
    virtual void setConfig(const char* key, const char* val) override;
    virtual bool init(const char*) override;
    virtual bool process(LogRecordInfoPtr) override;
protected:
    uint32_t show_element_;
    uint32_t log_max_size_ = 0;
};

}

#endif  // RP_PROCESS_LOG_CPP_FORMATER_H
