#ifndef RP_PROCESS_LOG_CPP_SINK_TOFILE_H
#define RP_PROCESS_LOG_CPP_SINK_TOFILE_H

#include <mutex>
#include <chrono>
#include <rp_process_log/process_log_define.h>
#include <rp_process_log/process_log_cpp_base.h>

namespace rp_process_log {

//设置输出路径
#define CONFIG_KEY_DUMP_PATH      "path"
//设置文件前缀
#define CONFIG_KEY_DUMP_PREFIX    "prefix"
//设置文件后缀
#define CONFIG_KEY_DUMP_SUFFIX    "suffix"

CLASS_FORWARD(ProcessLogCppSinkToFile)

/**
*  @class ProcessLogCppSinkToFile
*  @brief 日志输出文件类
*  @author luyp
*/
class ProcessLogCppSinkToFile : public ProcessLogCppBase
{
public:
    ProcessLogCppSinkToFile(const char* module);
    virtual ~ProcessLogCppSinkToFile() = default;

    virtual bool init(const char*) override;
    virtual bool process(LogRecordInfoPtr) override;
    virtual void setConfig(const char* key, const char* val) override;

protected:
    bool newStampFile();
    bool checkFile(LogRecordInfoPtr info);

    std::string path_;
    std::string prefix_;
    std::string suffix_;
    //std::string module_;
    std::mutex  mutex_;
    time_t      time_log_ = 0;

    std::shared_ptr<std::ofstream> out_file_ = nullptr;
};

}

#endif  // RP_PROCESS_LOG_CPP_SINK_TOFILE_H
