#ifndef MY_PROCESS_LOG_MODULE_DEFINE_H
#define MY_PROCESS_LOG_MODULE_DEFINE_H

#include <memory>
#include <functional>

#define UNUSE(x) (void)x

#define __PRETTY_FUNCTION__ __FUNCTION__

#define DEBUG_LOG(x) std::cout<<x<<std::endl

#define CLASS_FORWARD(c) class c;\
    typedef std::shared_ptr<c> c##Ptr;

#define RIGIST_RP_PROCESS_LOG_MODULE(name, module_class) \
    rp_process_log::g_module_generators.insert({name, [=](std::string module_name){return std::make_shared<module_class>(module_name.c_str());}})

#endif  // MY_PROCESS_LOG_MODULE_DEFINE_H
