#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
//#include <unistd.h>
#include <string.h>
#include <chrono>
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <rp_process_log/process_log_define.h>
#include <rp_process_log/process_log_cpp_filter.h>

namespace rp_process_log {

//REGIST_RP_PROCESS_LOG_MODULE("filter", ProcessLogCppFilter)

static std::map<std::string, LogLevel> g_levelMap = {
    {CONFIG_VAL_LEVEL_NONE,LV_NULL},
    {CONFIG_VAL_LEVEL_FATAL,LV_FATAL},
    {CONFIG_VAL_LEVEL_ERROR,LV_ERROR},
    {CONFIG_VAL_LEVEL_WARN,LV_WARN},
    {CONFIG_VAL_LEVEL_INFO,LV_INFO},
    {CONFIG_VAL_LEVEL_DEBUG,LV_DEBUG},
    {"", LV_ALL},
};

ProcessLogCppFilter::ProcessLogCppFilter(const char* module) :
    ProcessLogCppBase(module)
{
    level_ = LV_ALL;
}

bool ProcessLogCppFilter::init(const char*)
{
    return true;
}

void ProcessLogCppFilter::setConfig(const char* key, const char* val)
{
    if(strcmp(key, CONFIG_KEY_LEVEL_PASS) == 0)
    {
        if(g_levelMap.count(val))
        {
            level_ = g_levelMap[val];
        }
    }

    if(strcmp(key, CONFIG_KEY_FILTER_KEY) == 0)
    {
        std::string sval(val);
        if(sval.size())
        {
            if(sval.find("!") == 0)
            {
                reverse_filter_keys_.insert(sval.substr(1));
            }
            else
            {
                forward_filter_keys_.insert(val);
            }
        }
        //filter_key_ = val;
    }

    if(strcmp(key, CONFIG_KEY_FILTER_SRC_FILE) == 0)
    {
        filter_file_ = val;
    }
}

bool ProcessLogCppFilter::process(LogRecordInfoPtr info)
{
    auto level  = info->level;

    if(level > level_ )
    {
        return false;
    }

    if(filter_file_.size() && filter_file_ != info->filename)
    {
        return false;
    }

    if(reverse_filter_keys_.size() && reverse_filter_keys_.count(info->key))
    {
        return false;
    }

    if(forward_filter_keys_.size() && !forward_filter_keys_.count(info->key))
    {
        return false;
    }
//    if(filter_key_.size())
//    {
//        if(filter_key_.at(0) != '!')
//        {
//            if(filter_key_ != info->key)
//            {
//                return false;
//            }
//        }
//        else
//        {
//            if(strcmp(filter_key_.c_str() + 1, info->key.c_str()) == 0)
//            {
//                return false;
//            }
//        }
//    }

    return ProcessLogCppBase::process(info);
}



}
