#include <memory>
#include <iostream>
#include <map>
#include <vector>
#include <string>
#include <fstream>
#include <sstream>
#include <platform_api/common/platform_unistd.h>
#include <thread>
#ifdef _WIN32
#include <windows.h>
#endif
#include <rp_process_log/process_log_cpp.h>
#include <rp_process_log/process_log_frame.h>
//#include <ros/console.h>


using namespace std;
#ifdef __NOTE
std::string cfg = R"(
                  {
                              "frame" : {
                                      "plugin_root":"/home/sta/work/build-test_2-Desktop_Qt_5_9_9_GCC_64bit-Debug"
                                    },
                              "modules": [
                                      {"name":"formater", "module":"formater", "config":[
                                          {"key":"show_info", "val":"level"},
                                          {"key":"show_info", "val":"time"},
                                          {"key":"show_info", "val":"file"},
                                          {"key":"show_info", "val":"line"},
                                          {"key":"show_info", "val":"key"},
                                          {"key":"show_info", "val":"module"},
                                          {"key":"log_max_size", "val":"20"}
                                      ]},
                                      {"name":"filter", "module":"filter", "config":[
                                          {"key":"level", "val":"ERROR"},
                                          {"key":"key", "val":"!test"}
                                      ]},
                                      {"name":"filter2", "module":"filter", "config":[
                                          {"key":"level", "val":"INFO"},
                                          {"key":"key", "val":"test"}
                                      ]},
                                      {"name":"asyncer", "module":"asyncer", "config":[
                                      ]},
                                      {"name":"printer", "module":"printer", "config":[
                                      ]},
                                      {"name":"writer", "module":"writer", "config":[
                                        {"key":"path", "val":"/home/sta/tmp/tmp"},
                                        {"key":"suffix", "val":"errorlog"}
                                      ]},
                                      {"name":"writer2", "module":"writer", "config":[
                                        {"key":"path", "val":"/home/sta/tmp/tmp"},
                                        {"key":"suffix", "val":"all"}
                                      ]}
                                    ],
                              "links":[
                                {"module":"formater", "next":[
                                    {"module":"filter", "type":0},
                                    {"module":"asyncer", "type":0}
                                ]},
                                {"module":"asyncer", "next":[
                                    {"module":"filter2", "type":0}
                                ]},
                                {"module":"filter", "next":[
                                    {"module":"writer", "type":0}
                                ]},
                                {"module":"filter2", "next":[
                                    {"module":"writer2", "type":0}
                                ]}
                                ],


                              "links1":["filter", "asyncer", "formater", "writer"]
                   }
                  )";
#endif
#if 0
std::string cfg = R"(
                  {

                              "modules": [
                                      {"name":"formater", "module":"formater", "config":[
                                          {"key":"show_info", "val":"level"},
                                          {"key":"show_info", "val":"time"},
                                          {"key":"show_info", "val":"module"}
                                      ]},
                                      {"name":"filter", "module":"filter", "config":[
                                          {"key":"level", "val":""},
                                          {"key":"key", "val":""}
                                      ]},
                                      {"name":"printer", "module":"printer", "config":[
                                      ]},
                                      {"name":"writer", "module":"writer", "config":[
                                        {"key":"path", "val":"/home/sta/tmp/tmp"},
                                        {"key":"suffix", "val":"info"}
                                      ]}
                                    ],
                              "links":[

                                {"module":"filter", "next":[
                                    {"module":"formater", "type":0}
                                ]},
                                {"module":"formater", "next":[
                                    {"module":"printer", "type":0},
                                    {"module":"writer", "type":0}
                                ]}
                                ]
                   }
                  )";
#endif

static std::string getFileContext(std::string filename)
{
    std::stringstream ss;
    std::ifstream ifs;
    ifs.open(filename, std::ios::in | std::ios::binary);
    if(!ifs.is_open())
    {
        std::cerr<<"config file not found"<<std::endl;
        exit(1);
    }

    ss << ifs.rdbuf();
    return ss.str();
}

static std::string getExeName()
{
#define PATH_MAX 4096
#ifdef __linux
    char result[PATH_MAX];
    ssize_t count = readlink( "/proc/self/exe", result, PATH_MAX );
    std::string exePath = std::string( result, (count > 0) ? static_cast<size_t>(count) : 0 );
    size_t pos = exePath.find_last_of("\\/");
    return (std::string::npos == pos)
            ? exePath
            : exePath.substr(pos + 1);
#else
    char result[PATH_MAX];
    GetModuleFileNameA(NULL, result, 255);
    std::string exePath = std::string(result);

    size_t pos = exePath.find_last_of("\\");
    return exePath.substr(0, pos);;
#endif
}

static std::string getExePath()
{
#define PATH_MAX 4096
#ifdef __linux
    char result[PATH_MAX];
    ssize_t count = readlink( "/proc/self/exe", result, PATH_MAX );
    std::string exePath = std::string( result, (count > 0) ? static_cast<size_t>(count) : 0 );
    size_t pos = exePath.find_last_of("\\/");
    return (std::string::npos == pos)
            ? ""
            : exePath.substr(0, pos);
#else
    char result[PATH_MAX];
    GetModuleFileName(NULL, result, 255);
    std::string exePath = std::string(result);

    size_t pos = exePath.find_last_of("\\");
    return exePath.substr(0, pos);
#endif
}
//#define DEBUG

struct LOG_RECORD
{
    std::string leve;
    std::string key;
    std::string log;
};

#define TEST_SPLIT " "
#define DEBUG_LOG(x) std::cout<<x<<std::endl
int main(int argc, char** argv)
{

#ifdef DEBUG
    std::string str_logs_file = "/home/sta/work/rp_process_log_test/build/rp_process_log_record2";
    long count = 1;
    std::string module_path = "/home/sta/work/rp_process_log_test/build";

#else
    if(argc < 3)
    {
        DEBUG_LOG("usage: [proc] [test log file] [cout]");
        return 0;
    }
    std::string str_logs_file  = argv[1];
    long count = std::atol(argv[2]);
    auto module_path = getExePath();
#endif
    std::vector<LOG_RECORD>   log_records;

    //auto cfg = getFileContext(module_path + "/" + "rp_process_log.cfg");
    //auto module_name = getExeName();
    //rp_process_log::ProcessLogFrame::getInstance()->init(cfg.c_str(), module_name.c_str());

    std::ifstream logstream(str_logs_file, std::ios::in);
    if(!logstream.is_open())
    {
        std::cerr<<"cannot found logs file"<<std::endl;
        return 1;
    }
    else
    {
        while(!logstream.eof())
        {
            std::string level, key, log;
            std::string tmplog;
            std::getline(logstream, tmplog);

            if(tmplog.size())
            {
                size_t pend = 0;

                {
                    auto pstart = tmplog.find_first_not_of(TEST_SPLIT);

                    if(pstart == std::string::npos)
                    {
                        break;
                    }
                    pend  = tmplog.find_first_of(TEST_SPLIT, pstart + 1);
                    level = tmplog.substr(pstart , pend - pstart);
                    if(pend != std::string::npos)
                    {
                        pend++;
                    }
                    else
                    {
                        continue;
                    }
                }
                do
                {
                    auto pstart = pend;
                    pstart = tmplog.find_first_not_of(TEST_SPLIT, pstart);

                    if(pstart == std::string::npos)
                    {
                        break;
                    }
                    pend = tmplog.find_first_of(TEST_SPLIT, pstart + 1);
                    key = tmplog.substr(pstart , pend - pstart);
                    if(pend != std::string::npos) pend++;
                }while(false);
                do
                {
                    if(pend == std::string::npos)
                    {
                        log = key;
                        key.clear();
                    }
                    else
                    {
                        auto pstart = pend;

                        if(pstart == std::string::npos)
                        {
                            break;
                        }
                        //pend = tmplog.find_first_of(TEST_SPLIT, pstart + 1);
                        //log = tmplog.substr(pstart , pend - pstart);
                        log = tmplog.substr(pstart);
                    }
                }while(false);
                
                log_records.push_back({level, key, log});
            }
        }
    }

    while(count-- > 0)
    {
        for(auto& record : log_records)
        {
            if(record.leve == "INFO") RP_INFO_STREAM_K(record.log, record.key);
            if(record.leve == "DEBUG") RP_DEBUG_STREAM_K(record.log, record.key);
            if(record.leve == "WARN") RP_WARN_STREAM_K(record.log, record.key);
            if(record.leve == "ERROR") RP_ERROR_STREAM_K(record.log, record.key);
            if(record.leve == "FATAL") RP_FATAL_STREAM_K(record.log, record.key);

            if(record.leve == "INFO") RP_INFO_K(record.key, record.log.c_str());
            if(record.leve == "DEBUG") RP_DEBUG_K(record.key, record.log.c_str());
            if(record.leve == "WARN") RP_WARN_K(record.key, record.log.c_str());
            if(record.leve == "ERROR") RP_ERROR_K(record.key, record.log.c_str());
            if(record.leve == "FATAL") RP_FATAL_K(record.key, record.log.c_str());


            // RP_INFO_IF_K(record.key, 2==1, "false");
            // RP_INFO_IF_K(record.key, 1==1, "true");
            // RP_DEBUG_IF_STREAM_K(record.key, 2==1, "false");
            // RP_DEBUG_IF_STREAM_K(record.key, 1==1, "true");
        }
        RP_WARN_IF_STREAM(1==1, "false");
        //while()
    }
    std::cout<<"log end"<<std::endl;
    std::this_thread::sleep_for(std::chrono::seconds(500));
    return 0;
}
